// AlphaMapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "AlphaMapDlg.h"
#include ".\alphamapdlg.h"
#include "ProjMgr.h"
#include "ImgMatEdit.h"


// CAlphaMapDlg dialog

IMPLEMENT_DYNAMIC(CAlphaMapDlg, CDialog)
CAlphaMapDlg::CAlphaMapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAlphaMapDlg::IDD, pParent)
{
}

CAlphaMapDlg::~CAlphaMapDlg()
{
}

void CAlphaMapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CAlphaMapDlg, CDialog)
	ON_BN_CLICKED(IDC_OPALPHA, OnBnClickedOpalpha)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CAlphaMapDlg message handlers

void CAlphaMapDlg::OnBnClickedOpalpha()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(true, "bmp", ".bmp", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST, "Windows Bitmap File|*.bmp||");
	if( dlg.DoModal() == IDOK ){
		strcpy(g_ProjMgr.m_alphaimage_fn, LPCTSTR(dlg.GetPathName()));
		if(!g_ImgMatEdit.LoadAlphaImg(g_ProjMgr.m_alphaimage_fn)){
			::MessageBox( this->m_hWnd, "Can not open this file!", 0, 0);
		}

		RedrawWindow();
	}
}

void CAlphaMapDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages
	CStatic *control = NULL;
	CDC* pdc = NULL;
	CRect r;
	
	//control->GetWindowRect(&r);

	RgbImage & outimg = g_ImgMatEdit.m_alphaimg;

	if( outimg.m_width != 0 && outimg.m_height != 0){
		control = (CStatic*)GetDlgItem(IDC_ALPHAIMG);
		control->GetClientRect(&r);


		float rate1 = (r.right-2)/(float)outimg.m_width;
		float rate2 = (r.bottom-2)/(float)outimg.m_height;
		float rate = min(rate1, rate2);
		if( rate > 1.0f )
			rate = 1.0f;

		int DestW = (int)(rate * outimg.m_width);
		int DestH = (int)(rate * outimg.m_height);
		int DestX = (r.right-2)/2 - DestW/2;
		int DestY = (r.bottom-2)/2 - DestH/2;

		pdc = control->GetDC();
		::SetStretchBltMode(pdc->m_hDC, COLORONCOLOR);
		::StretchDIBits(pdc->m_hDC,
			DestX,
			DestY + DestH,
			DestW,
			-DestH,
			0,
			0,
			outimg.m_width,
			outimg.m_height,
			(void*)m_abmp.GetAlignedData(outimg),
			&getBitmapInfo(outimg),
			DIB_RGB_COLORS,
			SRCCOPY);
		ReleaseDC(pdc);
	}
}
