#pragma once

namespace math{

class Matrix{
public:
	Matrix();
	Matrix(const Matrix & rh); //copy constructor
	Matrix(int row, int col);
	bool resize(int row, int col);
	void reset();
	~Matrix();

	int m_row;
	int m_col;

	inline const double & entry(int row, int col) const{ return m_buf[row*m_col + col]; }
	inline double & entry(int row, int col){ return m_buf[row*m_col + col]; }

	void identity();
	double determinant();
	void zero();

	//bool getInverse(aMatrix & result);
	Matrix getTranspose();
	Matrix getInverse();
	void SwapRow(int row1, int row2);
	void AddRow(int row1, int row2);
	
	
	
	Matrix & operator=(const Matrix & rh);

	Matrix operator*(const Matrix & rh) const;
	Matrix operator*(double scale) const;
	Matrix operator+(const Matrix & rh) const;

	Matrix & operator*=(const Matrix & rh);
	Matrix & operator*=(double scale);
	Matrix & operator+=(const Matrix & rh);

	//new access function 
	inline double & operator()(int row, int col){
		return m_buf[row*m_col + col];
	}

	inline const double & operator()(int row, int col) const{
		return m_buf[row*m_col + col];
	}
	
private:
	double* m_buf;
};

}