// DepthGradDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "ImgMatEdit.h"
#include "DepthGradDlg.h"
#include ".\depthgraddlg.h"


// CDepthGradDlg dialog

IMPLEMENT_DYNAMIC(CDepthGradDlg, CDialog)
CDepthGradDlg::CDepthGradDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDepthGradDlg::IDD, pParent)
{
}

CDepthGradDlg::~CDepthGradDlg()
{
}

void CDepthGradDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER_N, m_n_slider);
	DDX_Control(pDX, IDC_SLIDER_VARIANCE_L, m_varL_slider);
	DDX_Control(pDX, IDC_SLIDER_VARIANCE_S, m_varS_slider);
	DDX_Control(pDX, IDC_SLIDER_GRADIENT_RESHAPE, m_reshape_slider);
}

BOOL CDepthGradDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_varL_slider.SetPos(10);
	m_varS_slider.SetPos(40);
	m_n_slider.SetPos(73);
	m_reshape_slider.SetRange(0, 6);
	m_reshape_slider.SetPos(3);

	return true;
}

BEGIN_MESSAGE_MAP(CDepthGradDlg, CDialog)
	ON_BN_CLICKED(IDC_DEPTH_DEFAULT, OnBnClickedDepthDefault)
	ON_BN_CLICKED(IDC_DEPTH_APPLY, OnBnClickedDepthApply)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_USE_GROSS, OnBnClickedUseGross)
END_MESSAGE_MAP()


// CDepthGradDlg message handlers

void CDepthGradDlg::OnBnClickedDepthDefault()
{
	// Make the original setting for depth estimator
	m_varL_slider.SetPos(10);
	m_varS_slider.SetPos(40);
	m_n_slider.SetPos(73);
	m_reshape_slider.SetPos(3);
}

void CDepthGradDlg::OnBnClickedDepthApply()
{	
	
	float vars = (float)(0.0001 + m_varS_slider.GetPos()/10000.0);			// 0.0~0.01;
	float varl = (float)(0.00001 + m_varL_slider.GetPos()/100.0);				// 0.0~1.0;
	int	reshape = m_reshape_slider.GetPos();				// 0~4;
	float n = (float)(m_n_slider.GetPos()/100.0);					// 0.0~1.0;
	
	// Estimate the depth, normal, and gradient of the object
	
	g_ImgMatEdit.shape_estimator.SetParameter(vars, varl, n, reshape);

	if(g_ImgMatEdit.m_use_gross == false || g_ImgMatEdit.m_do_gross_spec == false)
	g_ImgMatEdit.shape_estimator.Estimate(	&g_ImgMatEdit.m_intensity,		// Input image
											&g_ImgMatEdit.m_alphaimg,		// Input matte
											&g_ImgMatEdit.m_depth_img,		// Output depth
											&g_ImgMatEdit.m_gradient_img,	// Output gradient (R = dx, G = dy)
											&g_ImgMatEdit.m_normal_img);	// Output normal (R = x, G = y, B = z)
	else
		// Use gross image
		g_ImgMatEdit.shape_estimator.Estimate(	&g_ImgMatEdit.m_gross_intensity,// Input image
											&g_ImgMatEdit.m_alphaimg,			// Input matte
											&g_ImgMatEdit.m_depth_img,			// Output depth
											&g_ImgMatEdit.m_gradient_img,		// Output gradient (R = dx, G = dy)
											&g_ImgMatEdit.m_normal_img);		// Output normal (R = x, G = y, B = z)

	// Draw the preview image
	g_ImgMatEdit.shape_estimator.CreatePreview(	&g_ImgMatEdit.m_depth_img, 
												&g_ImgMatEdit.m_alphaimg, 
												&g_ImgMatEdit.m_depth_previmg);
	/*FloatRgbImage tmpimg;
	g_ImgMatEdit.FastToneMapping(g_ImgMatEdit.m_gradient_img, tmpimg);

	WriteBmpFile(ToNormalImage(tmpimg), "gradient.bmp");*/

	RedrawWindow();
}

void CDepthGradDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CStatic *control = NULL;
	CDC* pdc = NULL;
	CRect r;

	RgbImage & outimg = g_ImgMatEdit.m_depth_previmg;

	if( outimg.m_width != 0 && outimg.m_height != 0){
		control = (CStatic*)GetDlgItem(IDC_DEPTHIMG);
		control->GetClientRect(&r);


		float rate1 = (r.right-2)/(float)outimg.m_width;
		float rate2 = (r.bottom-2)/(float)outimg.m_height;
		float rate = min(rate1, rate2);
		if( rate > 1.0f )
			rate = 1.0f;

		int DestW = (int)(rate * outimg.m_width);
		int DestH = (int)(rate * outimg.m_height);
		int DestX = (r.right-2)/2 - DestW/2;
		int DestY = (r.bottom-2)/2 - DestH/2;

		pdc = control->GetDC();
		::SetStretchBltMode(pdc->m_hDC, COLORONCOLOR);
		::StretchDIBits(pdc->m_hDC,
			DestX,
			DestY + DestH,
			DestW,
			-DestH,
			0,
			0,
			outimg.m_width,
			outimg.m_height,
			(void*)m_abmp.GetAlignedData(outimg),
			&getBitmapInfo(outimg),
			DIB_RGB_COLORS,
			SRCCOPY);
		ReleaseDC(pdc);
	}
}

void CDepthGradDlg::OnBnClickedUseGross()
{
	g_ImgMatEdit.m_use_gross = !g_ImgMatEdit.m_use_gross;
}
