// GrossDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "GrossDlg.h"
#include "ImgMatEdit.h"
#include "utility.h"
#include "HisDlg.h"
#include ".\grossdlg.h"


// CGrossDlg dialog

IMPLEMENT_DYNAMIC(CGrossDlg, CDialog)
CGrossDlg::CGrossDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrossDlg::IDD, pParent)
{
}

CGrossDlg::~CGrossDlg()
{
}

void CGrossDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER_ALPHA, m_alpha_slider);
	DDX_Control(pDX, IDC_SLIDER_BETA, m_beta_slider);
	DDX_Control(pDX, IDC_A_EDIT, m_alpha_edit);
	DDX_Control(pDX, IDC_B_EDIT, m_beta_edit);
	//DDX_Control(pDX, IDC_SLIDER_LMIN, m_lmin_slider);
	//DDX_Control(pDX, IDC_LMIN_EDIT, m_lmin_edit);
	DDX_Control(pDX, IDC_GROSS_LMIN, m_lmin_text);
}


BEGIN_MESSAGE_MAP(CGrossDlg, CDialog)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIO_SPECULAR, OnBnClickedRadioSpecular)
	ON_BN_CLICKED(IDC_RADIO_GROSS, OnBnClickedRadioGross)
	ON_BN_CLICKED(IDC_GROSS_APPLY, OnBnClickedGrossApply)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_USEHIS, OnBnClickedUsehis)
	ON_BN_CLICKED(IDC_SELECT_LMIN, OnBnClickedSelectLmin)
	ON_WM_SETFOCUS()
	ON_REGISTERED_MESSAGE(WM_RELOAD_UI_DATA, OnReloadUiData)
END_MESSAGE_MAP()


// CGrossDlg message handlers

BOOL CGrossDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;

	if( gs_info.use_histogram )
		((CButton*) GetDlgItem(IDC_USEHIS))->SetCheck(1);
	else
		((CButton*) GetDlgItem(IDC_USEHIS))->SetCheck(0);

	if( gs_info.is_gross ){
		CheckRadioButton(IDC_RADIO_GROSS, IDC_RADIO_SPECULAR, IDC_RADIO_GROSS);
		m_alpha_edit.EnableWindow(FALSE);
		m_alpha_slider.EnableWindow(FALSE);
	}else{
		CheckRadioButton(IDC_RADIO_GROSS, IDC_RADIO_SPECULAR, IDC_RADIO_SPECULAR);
		m_alpha_edit.EnableWindow(TRUE);
		m_alpha_slider.EnableWindow(TRUE);

	}

	char buf[128];

	m_alpha_slider.SetPos(AlphaToPos(gs_info.alpha, gs_info.is_gross));
	m_beta_slider.SetPos(BetaToPos(gs_info.beta, gs_info.is_gross));

	sprintf(buf, "%f", gs_info.alpha);
	m_alpha_edit.SetWindowText(buf);
	sprintf(buf, "%f", gs_info.beta);
	m_beta_edit.SetWindowText(buf);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CGrossDlg::DoGrossSpec(){

	g_ImgMatEdit.GrossSpecular();
	CStatic *control = (CStatic*)GetDlgItem(IDC_GROSSIMG);
	DrawToStatic(control, g_ImgMatEdit.m_gross_previmg, m_abmp, true);
}


void CGrossDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	CString strText;

	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;


	gs_info.alpha = PosToAlpha(m_alpha_slider.GetPos(), gs_info.is_gross);
	strText.Format("%f", gs_info.alpha);
	m_alpha_edit.SetWindowText(strText);

	gs_info.beta = PosToBeta(m_beta_slider.GetPos(), gs_info.is_gross);
	strText.Format("%f", gs_info.beta );
	m_beta_edit.SetWindowText(strText);

	//this->UpdateData(false);

	DoGrossSpec();

	//DoGross();
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CGrossDlg::OnBnClickedRadioSpecular()
{
	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;
	gs_info.is_gross = false;
	CString strText;

	gs_info.beta = PosToBeta(m_beta_slider.GetPos(), gs_info.is_gross);
	strText.Format("%f", gs_info.beta);
	m_beta_edit.SetWindowText(strText);

	gs_info.alpha = PosToAlpha(m_alpha_slider.GetPos(), gs_info.is_gross);
	strText.Format("%f", gs_info.alpha);
	m_alpha_edit.SetWindowText(strText);

	//pSlide = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_ALPHA);
	m_alpha_slider.EnableWindow(TRUE);
	m_alpha_edit.EnableWindow(TRUE);

	DoGrossSpec();
}

void CGrossDlg::OnBnClickedRadioGross()
{
	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;
	gs_info.is_gross = true;
	CString strText;

	gs_info.beta = PosToBeta(m_beta_slider.GetPos(), gs_info.is_gross);
	strText.Format("%f", gs_info.beta);
	m_beta_edit.SetWindowText(strText);

	gs_info.alpha = PosToAlpha(m_alpha_slider.GetPos(), gs_info.is_gross);
	strText.Format("%f", gs_info.alpha);
	m_alpha_edit.SetWindowText(strText);

	
	m_alpha_slider.EnableWindow(FALSE);
	m_alpha_edit.EnableWindow(FALSE);

	DoGrossSpec();
}

void CGrossDlg::OnBnClickedGrossApply()
{
	// TODO: Add your control notification handler code here

	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;
	CString strText;
	m_alpha_edit.GetWindowText(strText);
	gs_info.alpha = (float)atof(strText);

	m_beta_edit.GetWindowText(strText);
	gs_info.beta = (float)atof(strText);

	g_ImgMatEdit.GrossSpecular();
	RedrawWindow();
}

void CGrossDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	CStatic *control = (CStatic*)GetDlgItem(IDC_GROSSIMG);
	DrawToStatic(control, g_ImgMatEdit.m_gross_previmg, m_abmp, true);
}

void CGrossDlg::OnBnClickedUsehis()
{
	// TODO: Add your control notification handler code here
	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;
	gs_info.use_histogram = !gs_info.use_histogram;

	if( !gs_info.use_histogram && gs_info.user_def_lmin < 0){
		OnBnClickedSelectLmin();
	}


}

void CGrossDlg::OnBnClickedSelectLmin()
{
	// TODO: Add your control notification handler code here
	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;

	CHisDlg hisdlg(this);
	char buf[128];
	if( hisdlg.DoModal() == IDOK ){
		gs_info.user_def_lmin = hisdlg.GetValue();
		sprintf(buf, "%f", gs_info.user_def_lmin);
		m_lmin_text.SetWindowText(buf);
	}

	DoGrossSpec();
}

LRESULT CGrossDlg::OnReloadUiData(WPARAM wParam, LPARAM lParam){
	GROSS_SPEC_INFO & gs_info = g_ImgMatEdit.m_gross_spec_info;

	if( gs_info.use_histogram )
		((CButton*) GetDlgItem(IDC_USEHIS))->SetCheck(1);
	else
		((CButton*) GetDlgItem(IDC_USEHIS))->SetCheck(0);

	if( gs_info.is_gross ){
		CheckRadioButton(IDC_RADIO_GROSS, IDC_RADIO_SPECULAR, IDC_RADIO_GROSS);
		m_alpha_edit.EnableWindow(FALSE);
		m_alpha_slider.EnableWindow(FALSE);
	}else{
		CheckRadioButton(IDC_RADIO_GROSS, IDC_RADIO_SPECULAR, IDC_RADIO_SPECULAR);
		m_alpha_edit.EnableWindow(TRUE);
		m_alpha_slider.EnableWindow(TRUE);

	}

	char buf[128];

	m_alpha_slider.SetPos(AlphaToPos(gs_info.alpha, gs_info.is_gross));
	m_beta_slider.SetPos(BetaToPos(gs_info.beta, gs_info.is_gross));

	sprintf(buf, "%f", gs_info.alpha);
	m_alpha_edit.SetWindowText(buf);
	sprintf(buf, "%f", gs_info.beta);
	m_beta_edit.SetWindowText(buf);

	return 0;
}


float CGrossDlg::PosToAlpha(int pos, bool gross){
	if( gross ){
		return (pos + 1.0f) / 1000.0f;  // 0.0 ~ 1.0
	}else{
		return (pos + 1.0f) / 1000.0f; // 0.0 ~ 0.1;
	}
}
float CGrossDlg::PosToBeta(int pos, bool gross){
	if ( gross ){
		return (pos + 1.0f)/100.0f;
	}else{
		return (pos + 1.0f)/100.0f;
	}
}

int CGrossDlg::AlphaToPos(float alpha, bool gross){
	if( gross ){
		return (int)(alpha*1000.0f - 1.0f);
	}else{
		return (int)(alpha*1000.0f - 1.0f);
	}
}

int CGrossDlg::BetaToPos(float beta, bool gross){
	if( gross ){
		return (int)(beta*100.0f - 1.0f);
	}else{
		return (int)(beta*100.0f - 1.0f);
	}
}
void CGrossDlg::OnSetFocus(CWnd* pOldWnd)
{
	CDialog::OnSetFocus(pOldWnd);
	DoGrossSpec();
	// TODO: Add your message handler code here
}
