// Highlights.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "HighlightsDlg.h"
#include "ImgMatEdit.h"
#include "HisDlg.h"
#include "utility.h"
#include ".\highlightsdlg.h"


// CHighlightsDlg dialog

IMPLEMENT_DYNAMIC(CHighlightsDlg, CDialog)
CHighlightsDlg::CHighlightsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHighlightsDlg::IDD, pParent)
	, m_hlt_text(_T("none"))
	, m_hispeak_text(_T("none"))
	, m_Lmax_text(_T("none"))
	, m_usrhlt_text(_T("none"))
	, m_usr_mod(false)
{
}

CHighlightsDlg::~CHighlightsDlg()
{
}

void CHighlightsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_HLT_VALUE, m_hlt_text);
	DDX_Text(pDX, IDC_HISPEAK_VALUE, m_hispeak_text);
	DDX_Text(pDX, IDC_MAX_VALUE, m_Lmax_text);
	DDX_Text(pDX, IDC_USR_HLT_VALUE, m_usrhlt_text);
}


BEGIN_MESSAGE_MAP(CHighlightsDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_SELECTLMIN, OnBnClickedSelectlmin)
	ON_WM_SETFOCUS()
	ON_BN_CLICKED(IDC_DEFAULT_HLT, OnBnClickedDefaultHlt)
END_MESSAGE_MAP()


// CHighlightsDlg message handlers

void CHighlightsDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages

	CStatic *control = (CStatic*)GetDlgItem(IDC_HIGHLIGHTSMAP);
	DrawToStatic( control, g_ImgMatEdit.m_highlights_img, m_abmp, true);
}

BOOL CHighlightsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CHighlightsDlg::OnBnClickedSelectlmin()
{
	// TODO: Add your control notification handler code here
	CHisDlg hisdlg;
	if( hisdlg.DoModal() == IDOK){
		m_usrHlt = hisdlg.GetValue();
		m_usr_mod = true;
	}

	if( g_ImgMatEdit.m_do_histogram)
		g_ImgMatEdit.DetectHeightLightsPel(m_usrHlt, false);

	RedrawWindow();

}

void CHighlightsDlg::OnSetFocus(CWnd* pOldWnd)
{
	CDialog::OnSetFocus(pOldWnd);

	if( g_ImgMatEdit.m_do_histogram){
		const HISTOGRAM_INFO & his_info = g_ImgMatEdit.GetHisInfo();

		m_hlt_text.Format("%f", his_info.hl_threshold);
		m_hispeak_text.Format("%f", his_info.his_peak);
		m_Lmax_text.Format("%f", his_info.lmax);
		if( !m_usr_mod ){
			m_usrHlt = his_info.hl_threshold;
		}
		m_usrhlt_text.Format("%f", m_usrHlt);

		UpdateData(FALSE);

		g_ImgMatEdit.DetectHeightLightsPel(m_usrHlt, false);
	}
}

void CHighlightsDlg::OnBnClickedDefaultHlt()
{
	// TODO: Add your control notification handler code here
	if(  g_ImgMatEdit.m_do_histogram ){
		m_usrHlt = g_ImgMatEdit.GetHisInfo().hl_threshold;
		m_usr_mod = false;
		m_usrhlt_text.Format("%f", m_usrHlt);
		UpdateData(FALSE);
		g_ImgMatEdit.DetectHeightLightsPel(m_usrHlt, false);
		RedrawWindow();
	}
}
