// HisDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "HisDlg.h"
#include "ImgMatEdit.h"
#include "utility.h"
#include ".\hisdlg.h"


// CHisDlg dialog

IMPLEMENT_DYNAMIC(CHisDlg, CDialog)
CHisDlg::CHisDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHisDlg::IDD, pParent)
{
	m_out_init = false;
}

CHisDlg::~CHisDlg()
{
}

void CHisDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_VALUE_SLIDER, m_value_slider);
	DDX_Control(pDX, IDC_VALUE, m_value_text);
}


BEGIN_MESSAGE_MAP(CHisDlg, CDialog)
	ON_WM_HSCROLL()
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CHisDlg message handlers

BOOL CHisDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	char buf[128];

	if( !g_ImgMatEdit.m_do_histogram )
		g_ImgMatEdit.ImgHistogram();

	const HISTOGRAM_INFO & his_info = g_ImgMatEdit.GetHisInfo();

	m_value_slider.SetRange(0, 71*3 - 1);
	if( !m_out_init )
		m_log_value = g_ImgMatEdit.ValueToLog(his_info.hl_threshold);
	else
		m_log_value = g_ImgMatEdit.ValueToLog(m_log_value);

	m_value_slider.SetPos( (int)(m_log_value*3));
	
	CStatic * text_ptr = (CStatic*)GetDlgItem(IDC_VALUE_LOW);
	sprintf(buf, "%f", g_ImgMatEdit.LogToValue(his_info.his_base));
	text_ptr->SetWindowText(buf);

	text_ptr = (CStatic*)GetDlgItem(IDC_VALUE_HIGH);
	sprintf(buf, "%f", his_info.lmax);
	text_ptr->SetWindowText(buf);

	//

	g_ImgMatEdit.MarkHigherPel( g_ImgMatEdit.LogToValue(m_log_value), m_higher_img);

	DrawChart();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CHisDlg::DrawChart(){
	m_histogram_img = g_ImgMatEdit.m_histogram_chart;
	if( m_histogram_img.m_width == 0 || m_histogram_img.m_height == 0)
		return;

	int pos = (int)(m_log_value*3.0f);

	if( pos > m_histogram_img.m_width - 1){
		pos = m_histogram_img.m_width - 1;
	}

	for(int y = 0; y < m_histogram_img.m_height; y++){
		m_histogram_img.entry(pos, y) = uRGB(255, 0 , 0);
	}
}

void CHisDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default

	static char buf[128];
	m_log_value = m_value_slider.GetPos()/3.0f;

	sprintf(buf, "%f", g_ImgMatEdit.LogToValue(m_log_value));
	m_value_text.SetWindowText(buf);

	DrawChart();
	g_ImgMatEdit.MarkHigherPel( g_ImgMatEdit.LogToValue(m_log_value), m_higher_img);

	CStatic *control = (CStatic*)GetDlgItem(IDC_HISIMG);
	DrawToStatic(control, m_histogram_img, m_abmp1, false);
	control = (CStatic*)GetDlgItem(IDC_HIGHERIMG);
	DrawToStatic(control, m_higher_img, m_abmp2, true);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
void CHisDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here

	CStatic *control = (CStatic*)GetDlgItem(IDC_HISIMG);
	DrawToStatic(control, m_histogram_img, m_abmp1, false);
	control = (CStatic*)GetDlgItem(IDC_HIGHERIMG);
	DrawToStatic(control, m_higher_img, m_abmp2, true);

	// Do not call CDialog::OnPaint() for painting messages
}

float CHisDlg::GetValue(){
	return g_ImgMatEdit.LogToValue(m_log_value);
}

void CHisDlg::SetValue(float v){
	m_log_value = v;
	m_out_init = true;
}
