// IMETabCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "IMETabCtrl.h"
#include ".\imetabctrl.h"


// CIMETabCtrl

IMPLEMENT_DYNAMIC(CIMETabCtrl, CTabCtrl)
CIMETabCtrl::CIMETabCtrl()
{
}

CIMETabCtrl::~CIMETabCtrl()
{
	for(int nCount=0; nCount < (int)m_tabPages.size(); nCount++){
		delete m_tabPages[nCount];
	}
}

void CIMETabCtrl::AddTab(PCTSTR tabname, UINT id, CDialog* dlg){
	m_tabPages.push_back(dlg);
	m_ids.push_back(id);

	this->InsertItem((int)m_tabPages.size(), tabname);
}

void CIMETabCtrl::Init(){
	m_tabCurrent=0;

	for(int i = 0; i < (int)m_tabPages.size(); i++){
		m_tabPages[i]->Create(m_ids[i], this);
	}

	m_tabPages[0]->ShowWindow(SW_SHOW);

	for(int i = 0; i < (int)m_tabPages.size(); i++){
		m_tabPages[i]->ShowWindow(SW_HIDE);
	}
	
	
	SetRectangle();
}

void CIMETabCtrl::SetRectangle(){
	CRect tabRect, itemRect;
	int nX, nY, nXc, nYc;

	GetClientRect(&tabRect);
	GetItemRect(0, &itemRect);

	nX=itemRect.left;
	nY=itemRect.bottom+1;
	nXc=tabRect.right-itemRect.left-1;
	nYc=tabRect.bottom-nY-1;


	m_tabPages[0]->SetWindowPos(&wndTop, nX, nY, nXc, nYc, SWP_SHOWWINDOW);
	for(int nCount=1; nCount < (int)m_tabPages.size(); nCount++){
		m_tabPages[nCount]->SetWindowPos(&wndTop, nX, nY, nXc, nYc, SWP_HIDEWINDOW);
	}
}


BEGIN_MESSAGE_MAP(CIMETabCtrl, CTabCtrl)
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()



// CIMETabCtrl message handlers


void CIMETabCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CTabCtrl::OnLButtonDown(nFlags, point);

	if(m_tabCurrent != GetCurFocus()){
		m_tabPages[m_tabCurrent]->ShowWindow(SW_HIDE);
		m_tabCurrent=GetCurFocus();
		m_tabPages[m_tabCurrent]->ShowWindow(SW_SHOW);
		m_tabPages[m_tabCurrent]->SetFocus();
	}

	
}

CDialog* CIMETabCtrl::CurrentTab(){
	return m_tabPages[m_tabCurrent];
}

void CIMETabCtrl::EnableTab(UINT id, BOOL active){
	for(int i = 0; i < (int)m_ids.size(); i++){
		if( m_ids[i] == id){
			m_tabPages[i]->EnableWindow(active);
		}
	}
}
void CIMETabCtrl::EnableTab(BOOL active){
	for(int i = 0; i < (int)m_ids.size(); i++){
		m_tabPages[i]->EnableWindow(active);
	}
}

void CIMETabCtrl::SetFocusOn(UINT id){
	for(int i = 0; i < (int)m_ids.size(); i++){
		if( m_ids[i] == id){
			if(m_tabCurrent != i){
				m_tabPages[m_tabCurrent]->ShowWindow(SW_HIDE);
				m_tabCurrent= i;
				m_tabPages[m_tabCurrent]->ShowWindow(SW_SHOW);
				m_tabPages[m_tabCurrent]->SetFocus();
			}
		}
	}

}

void CIMETabCtrl::ReLoadUiData(){
	for(int i = 0; i < (int)m_tabPages.size(); i++){
		m_tabPages[i]->SendMessage(WM_RELOAD_UI_DATA, 0, 0);
	}

}