// Inpaint.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "InpaintDlg.h"
#include "ImgMatEdit.h"
#include ".\inpaintdlg.h"


// CInpaintDlg dialog

IMPLEMENT_DYNAMIC(CInpaintDlg, CDialog)
CInpaintDlg::CInpaintDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInpaintDlg::IDD, pParent)
{
}

CInpaintDlg::~CInpaintDlg()
{
}

void CInpaintDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_G_VALUE, m_show_g_value);
	DDX_Control(pDX, IDC_G_VALUE_SLIDER, m_g_value_slider);
}


BEGIN_MESSAGE_MAP(CInpaintDlg, CDialog)
	ON_BN_CLICKED(IDC_INPAINT, OnBnClickedInpaint)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
END_MESSAGE_MAP()


// CInpaintDlg message handlers

void CInpaintDlg::OnBnClickedInpaint()
{
	// TODO: Add your control notification handler code here
	g_ImgMatEdit.Inpaint();
	RedrawWindow();
	g_ImgMatEdit.brdf.make_samples(&g_ImgMatEdit.m_inpainted_img);
}

void CInpaintDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	CStatic *control = NULL;
	CDC* pdc = NULL;
	CRect r;

	RgbImage & outimg = g_ImgMatEdit.m_inpaint_previmg;

	if( outimg.m_width != 0 && outimg.m_height != 0){
		control = (CStatic*)GetDlgItem(IDC_INPAINTIMG);
		control->GetClientRect(&r);


		float rate1 = (r.right-2)/(float)outimg.m_width;
		float rate2 = (r.bottom-2)/(float)outimg.m_height;
		float rate = min(rate1, rate2);
		if( rate > 1.0f )
			rate = 1.0f;

		int DestW = (int)(rate * outimg.m_width);
		int DestH = (int)(rate * outimg.m_height);
		int DestX = (r.right-2)/2 - DestW/2;
		int DestY = (r.bottom-2)/2 - DestH/2;

		pdc = control->GetDC();
		::SetStretchBltMode(pdc->m_hDC, COLORONCOLOR);
		::StretchDIBits(pdc->m_hDC,
			DestX,
			DestY + DestH,
			DestW,
			-DestH,
			0,
			0,
			outimg.m_width,
			outimg.m_height,
			(void*)m_abmp.GetAlignedData(outimg),
			&getBitmapInfo(outimg),
			DIB_RGB_COLORS,
			SRCCOPY);
		ReleaseDC(pdc);
	}}

BOOL CInpaintDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here

	char buf[128];
	sprintf( buf, "%f", g_ImgMatEdit.m_g_value);
	m_show_g_value.SetWindowText(buf);
	m_g_value_slider.SetRange(1, 1000);
	m_g_value_slider.SetPos( (int)((g_ImgMatEdit.m_g_value - 1.0)*50) );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CInpaintDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	double g_value = ((CSliderCtrl*)pScrollBar)->GetPos();
	g_ImgMatEdit.m_g_value = (float)(1.0 + g_value/10.0);

	char buf[128];
	sprintf(buf, "%f",g_ImgMatEdit.m_g_value);
	m_show_g_value.SetWindowText(buf);
	
}
