#pragma once
#include <cstdlib>
#include <cstdio>
#include <cmath>

using namespace std;

#include "stdafx.h"

class matrix3;

class vector3
{
public:
	vector3();
	~vector3();
	void set(float xin, float yin, float zin);
	void middle(vector3 *i, vector3 *r);
	void normalize();
	void rotate(matrix3 *r, vector3 *v);
	float x;
	float y;
	float z;
};

class matrix3
{
public:
	matrix3();
	~matrix3();
	void set(float alpha, vector3 *v);
	void inverse(matrix3 *r);
	float m00, m01, m02;
	float m10, m11, m12;
	float m20, m21, m22;
};

float dot(vector3 *v1, vector3 *v2);
void cross_product(vector3 *a, vector3 *b, vector3 *c);