#include "projmgr.h"
#include "ImgMatEdit.h"

#include <cstdlib>
#include <fstream>
#include <exception>
#include "path_conv.h"
using namespace std;

ProjMgr g_ProjMgr;

ProjMgr::ProjMgr(void)
{
	NewProj();
}

ProjMgr::~ProjMgr(void)
{
}


bool ProjMgr::NewProj(){
	this->m_proj_fn[0] = '\0';
	this->m_srcimage_fn[0] = '\0';
	this->m_alphaimage_fn[0] = '\0';
	return true;
}

bool ProjMgr::OpenProj(char *filename){
	char buf[128];
	ifstream file(filename);

	if( file ){
		SetProjFilename(filename);

		ifstream verify_file;

		file.getline(buf, 128);
		if( strcmp(buf, "IME PROJ") != 0)
			return false;

		return LoadData(file);
		//file.getline(buf, 512);
		//Rel2Abs(buf, m_srcimage_fn, m_proj_dir);
		//file.getline(buf, 512);
		//Rel2Abs(buf, m_alphaimage_fn, m_proj_dir);

		//return true;
	}

	return false;
}

bool ProjMgr::SaveProj(char * filename){
	ofstream file;

	if( filename != NULL)
		file.open(filename, ios::trunc);
	else{
		if( m_proj_fn[0] == '\0')
			return false;
		file.open(m_proj_fn, ios::trunc);
	}

	if( file ){
		if( filename != NULL){
			SetProjFilename(filename);
		}
		file << "IME PROJ" << endl;
		return SaveData(file);
		//file << OutputFileName(m_srcimage_fn) << endl;
		//file << OutputFileName(m_alphaimage_fn) << endl;
		//return true;
	}
	return false;
}

string ProjMgr::OutputFileName(char* filename){
	char buf[512];

	if( filename[0] != '\0' && filename[0] != '\n')
		return string(Abs2Rel(filename, buf, m_proj_dir));
	else
		return string("N/A");

}

bool ProjMgr::SetProjFilename(char *filename){
	strcpy(m_proj_fn, filename);

	for(int i = (int)strlen(m_proj_fn) - 1; i >= 0; i--){
		if( m_proj_fn[i] == '\\' ){
			strncpy(m_proj_dir, m_proj_fn, i);
			m_proj_dir[i] = '\0';
			return true;
		}
	}
	return false;
}

/*
struct HISTOGRAM_INFO{
	float hl_threshold;
	float his_peak;
	float his_base;
	float lmax;
	float lmin;
	float bin_space;
};
*/
const char * vars[] = {
	"SRCIMG",                  //0
	"ALPHAIMG",                //1
	"TM_A",                    //2
	"TM_LW",                   //3
	"DO_GROSS",                //4
	"GROSS_ALPHA",             //5
	"GROSS_BETA",              //6
	"IS_GROSS",                //7
	"USE_HIS",                 //8
	"USR_DEF_LMIN",            //9
	"DO_HL",                   //10
	"HL_LMIN",                 //11
	"DO_INPAINT",              //12
	"G_VALUE",                 //13
	"DO_RETEX",                //14
	"SCALAR_S",                //15
	"SCALAR_F",                //16
	"SCALAR_TEX",              //17
	"TEX_SIZE",                //18
	"COLOR_R",                 //19
	"COLOR_G",                 //20
	"COLOR_B",                 //21
	"BLACK_GLASS",             //22
	"PRE_HL",                  //23
	"TX_MODE",                 //24

////////////////////////////////////////////////////////////////////
	"DO_DEPTH",				   //25
	"DEPTH_RESPONSE"		   //26
	"DEPTH_VARS"			   //27
	"DEPTH_VARL"               //28
	"DEPTH_RESHAPE",		   //29

	"DO_BRDF",				   //30
	"BRDF_RHOD",			   //31
	"BRDF_RHOS",			   //32
	"BRDF_RMS",				   //33
	"BRDF_GAIN_R",			   //34
	"BRDF_GAIN_G",			   //35
	"BRDF_GAIN_B",			   //36

	"USE_GROSS",			   //37
	NULL
};


bool ProjMgr::LoadData(ifstream & in){

	int var_idx = 0;

	char buf[1024];

	float tmp;

	while( !in.eof()){

		in >> buf;
		while ( vars[var_idx] != NULL ){

			if( strcmp(buf, vars[var_idx] ) == 0){
				break;
			}

			var_idx++;
		}

		if( vars[var_idx] != NULL ){
			switch(var_idx){
				case 0:
					in.get();
					in.getline(buf, 1024);
					Rel2Abs(buf, m_srcimage_fn, m_proj_dir);
					break;
				case 1:
					in.get();
					in.getline(buf, 1024);
					Rel2Abs(buf, m_alphaimage_fn, m_proj_dir);
					break;
				case 2:
					in >> tmp;
					break;
				case 3:
					in >> tmp;
					break;
				case 4:
					in >> g_ImgMatEdit.m_do_gross_spec;
					break;
				case 5:
					in >> g_ImgMatEdit.m_gross_spec_info.alpha;
					break;
				case 6:
					in >> g_ImgMatEdit.m_gross_spec_info.beta;
					break;
				case 7:
					in >> g_ImgMatEdit.m_gross_spec_info.is_gross;
					break;
				case 8:
					in >> g_ImgMatEdit.m_gross_spec_info.use_histogram;
					break;
				case 9:
					in >> g_ImgMatEdit.m_gross_spec_info.user_def_lmin;
					break;
				case 10:
					in >> g_ImgMatEdit.m_do_hightlights;
					break;
				case 11:
					in >> g_ImgMatEdit.m_highlight_lmin;
					break;
				case 12:
					in >> g_ImgMatEdit.m_do_inpaint;
					break;
				case 13:
					in >> g_ImgMatEdit.m_g_value;
					break;
				case 14:
					in >> g_ImgMatEdit.m_do_retexture;
					break;
				case 15:
					in >> g_ImgMatEdit.m_retex_info.scalar_s;
					break;
				case 16:
					in >> g_ImgMatEdit.m_retex_info.scalar_f;
					break;
				case 17:
					in >> g_ImgMatEdit.m_retex_info.scalar_tex;
					break;
				case 18:
					in >> g_ImgMatEdit.m_retex_info.tex_size;
					break;
				case 19:
					in >> g_ImgMatEdit.m_retex_info.color.R;
					break;
				case 20:
					in >> g_ImgMatEdit.m_retex_info.color.G;
					break;
				case 21:
					in >> g_ImgMatEdit.m_retex_info.color.B;
					break;
				case 22:
					in >> g_ImgMatEdit.m_retex_info.black_glass;
					break;
				case 23:
					in >> g_ImgMatEdit.m_retex_info.preserve_hl;
					break;
				case 24:
					int temp;
					in >> temp;
					if(temp == 0){
						g_ImgMatEdit.m_retex_info.mode = tx_transparency;
					}else{
						g_ImgMatEdit.m_retex_info.mode = tx_external;
					}
						
					break;
				////////////////////DEPTH/////////////////////////////////////
				case 25:
					in >> g_ImgMatEdit.m_do_shape;
					break;
				case 26:
					in >> g_ImgMatEdit.shape_estimator.n;
					break;
				case 27:
					in >> g_ImgMatEdit.shape_estimator.vars;
					break;
				case 28:
					in >> g_ImgMatEdit.shape_estimator.varl;
					break;
				case 29:
					in >> g_ImgMatEdit.shape_estimator.recursion;
					break;
				///////////////////BRDF///////////////////////////////////////
				case 30:
					in >> g_ImgMatEdit.m_do_brdf;
					break;
				case 31:
					in >> g_ImgMatEdit.brdf.rho_d;
					break;
				case 32:
					in >> g_ImgMatEdit.brdf.rho_s;
					break;
				case 33:
					in >> g_ImgMatEdit.brdf.rms;
					break;
				case 34:
					in >> g_ImgMatEdit.brdf.g_r;
					break;
				case 35:
					in >> g_ImgMatEdit.brdf.g_g;
					break;
				case 36:
					in >> g_ImgMatEdit.brdf.g_b;
					break;
				case 37:
					in >> g_ImgMatEdit.m_use_gross;
					break;
				default:
					break;
			}
		}
	}

	return true;
}

bool ProjMgr::Recompute(){
	if(g_ImgMatEdit.m_do_gross_spec){
		g_ImgMatEdit.GrossSpecular();
	}

	if(g_ImgMatEdit.m_do_inpaint){
		g_ImgMatEdit.Inpaint();
	}

	if(g_ImgMatEdit.m_do_retexture){
		g_ImgMatEdit.Retexture();
	}

	return true;
}


bool ProjMgr::SaveData(ofstream & out){

	if( !out )
		return false;

	out << "SRCIMG "      << OutputFileName(m_srcimage_fn) << endl;                     //0
	out << "ALPHAIMG "    << OutputFileName(m_alphaimage_fn) << endl;                   //1
	out << "TM_A "        << 0.0f << endl;                                              //2
	out << "TM_LW "       << 0.0f << endl;                                              //3
	out << "DO_GROSS "    << g_ImgMatEdit.m_do_gross_spec << endl;                      //4
	out << "GROSS_ALPHA " << g_ImgMatEdit.m_gross_spec_info.alpha << endl;              //5
	out << "GROSS_BETA "  << g_ImgMatEdit.m_gross_spec_info.beta << endl;               //6
	out << "IS_GROSS "    << g_ImgMatEdit.m_gross_spec_info.is_gross << endl;           //7
	out << "USE_HIS "     << g_ImgMatEdit.m_gross_spec_info.use_histogram << endl;      //8
	out << "USR_DEF_LMIN "<< g_ImgMatEdit.m_gross_spec_info.user_def_lmin << endl;      //9
	out << "DO_HL "       << g_ImgMatEdit.m_do_hightlights << endl;                     //10
	out << "HL_LMIN "     << g_ImgMatEdit.m_highlight_lmin << endl;                     //11
	out << "DO_INPAINT "  << g_ImgMatEdit.m_do_inpaint << endl;                         //12
	out << "G_VALUE "     << g_ImgMatEdit.m_g_value << endl;                            //13
	out << "DO_RETEX "    << g_ImgMatEdit.m_do_retexture << endl;                       //14
	out << "SCALAR_S "    << g_ImgMatEdit.m_retex_info.scalar_s << endl;                //15
	out << "SCALAR_F "    << g_ImgMatEdit.m_retex_info.scalar_f << endl;                //16
	out << "SCALAR_TEX "  << g_ImgMatEdit.m_retex_info.scalar_tex << endl;              //17
	out << "TEX_SIZE "    << g_ImgMatEdit.m_retex_info.tex_size << endl;                //18
	out << "COLOR_R "     << g_ImgMatEdit.m_retex_info.color.R << endl;                 //19
	out << "COLOR_G "     << g_ImgMatEdit.m_retex_info.color.G << endl;                 //20
	out << "COLOR_B "     << g_ImgMatEdit.m_retex_info.color.B << endl;                 //21
	out << "BLACK_GLASS " << g_ImgMatEdit.m_retex_info.black_glass << endl;             //22
	out << "PRE_HL "      << g_ImgMatEdit.m_retex_info.preserve_hl << endl;             //23
	out << "TX_MODE ";                                                                  //24
	if( g_ImgMatEdit.m_retex_info.mode == tx_transparency )
		out << 0 << endl;
	else
		out << 1 << endl;
	/////////////////////////////////////////////////////////////////////////////////////////
	out << "DO_DEPTH"			<< g_ImgMatEdit.m_do_shape << endl;
	out << "DEPTH_RESPONSE"		<< g_ImgMatEdit.shape_estimator.n << endl;
	out << "DEPTH_VARS"			<< g_ImgMatEdit.shape_estimator.vars << endl;
	out << "DEPTH_VARL"			<< g_ImgMatEdit.shape_estimator.varl << endl;
	out << "DEPTH_VARL"			<< g_ImgMatEdit.shape_estimator.recursion << endl;

	out << "DO_BRDF"			<< g_ImgMatEdit.m_do_brdf << endl;
	out << "BRDF_RHOD"			<< g_ImgMatEdit.brdf.rho_d << endl;
	out << "BRDF_RHOS"			<< g_ImgMatEdit.brdf.rho_s << endl;
	out << "BRDF_RMS"			<< g_ImgMatEdit.brdf.rms << endl;
	out << "BRDF_GAIN_R"		<< g_ImgMatEdit.brdf.g_r << endl;
	out << "BRDF_GAIN_G"		<< g_ImgMatEdit.brdf.g_g << endl;
	out << "BRDF_GAIN_B"		<< g_ImgMatEdit.brdf.g_b << endl;

	out << "USE_GROSS"			<< g_ImgMatEdit.m_use_gross << endl;
	return true;
}
