// Texture.cpp : implementation file
//

#include "stdafx.h"
#include "IME.h"
#include "TextureDlg.h"
#include "utility.h"
#include ".\texturedlg.h"


// CTextureDlg dialog

IMPLEMENT_DYNAMIC(CTextureDlg, CDialog)
CTextureDlg::CTextureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTextureDlg::IDD, pParent)
{
	m_dark_glass = false;
	m_preserve_hl = false;
}

CTextureDlg::~CTextureDlg()
{
}

void CTextureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SCALAR_S, m_scalar_s);
	DDX_Control(pDX, IDC_SCALAR_F, m_scalar_f);
	DDX_Control(pDX, IDC_SHOW_S, m_static_s);
	DDX_Control(pDX, IDC_STATIC_F, m_static_f);
	DDX_Control(pDX, IDC_SCALAR_TEX, m_scalar_tex);
	DDX_Control(pDX, IDC_TEX_SIZE, m_txsize_slider);
}


BEGIN_MESSAGE_MAP(CTextureDlg, CDialog)
	ON_BN_CLICKED(IDC_TRANSPARANCY, OnBnClickedTransparancy)
	ON_BN_CLICKED(IDC_EXTERNAL, OnBnClickedExternal)
	ON_BN_CLICKED(IDC_SETCOLOR, OnBnClickedSetcolor)
//	ON_BN_CLICKED(IDC_TEX_APPLY, OnBnClickedTexApply)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_DARK_GLASS, OnBnClickedDarkGlass)
	ON_BN_CLICKED(IDC_HL, OnBnClickedHl)
	ON_WM_SETFOCUS()
	ON_BN_CLICKED(IDC_LOADTEX, OnBnClickedLoadtex)
END_MESSAGE_MAP()


// CTextureDlg message handlers

BOOL CTextureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	if( g_ImgMatEdit.m_retex_info.mode == tx_transparency){
		CheckRadioButton(IDC_TRANSPARANCY, IDC_EXTERNAL, IDC_TRANSPARANCY);
	}else{
		CheckRadioButton(IDC_TRANSPARANCY, IDC_EXTERNAL, IDC_EXTERNAL);
	}
	//m_texture_mode = tx_transparency;
	m_color = fRGB(1.0f, 1.0f, 1.0f);

	
	m_scalar_s.SetRange(0, 1000);
	m_scalar_s.SetPos( GetPosFromS(g_ImgMatEdit.m_retex_info.scalar_s) );
	m_scalar_f.SetRange(0, 1000);
	m_scalar_f.SetPos( GetPosFromF(g_ImgMatEdit.m_retex_info.scalar_f) );
	m_scalar_tex.SetRange(0, 1000);
	m_scalar_tex.SetPos( GetPosFromTex(g_ImgMatEdit.m_retex_info.scalar_tex) );
	m_txsize_slider.SetRange(0, 1000);
	m_txsize_slider.SetPos( GetPosFromTexSize(g_ImgMatEdit.m_retex_info.tex_size) );


	char buf[128];
	sprintf(buf, "%f", g_ImgMatEdit.m_retex_info.scalar_s);
	m_static_s.SetWindowText(buf);
	sprintf(buf, "%f", g_ImgMatEdit.m_retex_info.scalar_f);
	m_static_f.SetWindowText(buf);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CTextureDlg::DoRetexture(){
	g_ImgMatEdit.Retexture();
	CStatic *control = (CStatic*)GetDlgItem(IDC_RETEXIMG);
	DrawToStatic(control, g_ImgMatEdit.m_retex_previmg, m_abmp, true);
}

void CTextureDlg::OnBnClickedTransparancy()
{
	// TODO: Add your control notification handler code here
	g_ImgMatEdit.m_retex_info.mode = tx_transparency;
	DoRetexture();
}

void CTextureDlg::OnBnClickedExternal()
{
	// TODO: Add your control notification handler code 
	g_ImgMatEdit.m_retex_info.mode = tx_external;

	if( g_ImgMatEdit.m_external_tex.m_width == 0 || g_ImgMatEdit.m_external_tex.m_height == 0){
		OnBnClickedLoadtex();
	}

	DoRetexture();
}

void CTextureDlg::OnBnClickedSetcolor()
{
	// TODO: Add your control notification handler code here
	CColorDialog cdlg(RGB( (BYTE)(m_color.R*255), (BYTE)(m_color.G*255), (BYTE)(m_color.B*255)), CC_FULLOPEN);
	if( cdlg.DoModal() == IDOK){
		COLORREF c = cdlg.GetColor();
		m_color.R = GetRValue(c)/255.0f;
		m_color.G = GetGValue(c)/255.0f;
		m_color.B = GetBValue(c)/255.0f;
		g_ImgMatEdit.m_retex_info.color = m_color;
	}

	DoRetexture();
}

//void CTextureDlg::OnBnClickedTexApply()
//{
//	//const float s_factor = 30.0f/500.0f;
//	//const float f_factor = 1.0f/500.0f;
//
//	g_ImgMatEdit.m_scalar_s = GetScalarS(m_scalar_s.GetPos());
//	g_ImgMatEdit.m_scalar_f = GetScalarF(m_scalar_f.GetPos());
//
//	if( !g_ImgMatEdit.Retexture(g_ImgMatEdit.m_scalar_s, g_ImgMatEdit.m_scalar_f, m_color, NULL, ImgMatEdit::tx_transparency, true, true)){
//		::MessageBox(m_hWnd, "Can not retexture...", 0, 0);
//	}
//	RedrawWindow();
//
//}

void CTextureDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	CStatic *control = (CStatic*)GetDlgItem(IDC_RETEXIMG);
	DrawToStatic(control, g_ImgMatEdit.m_retex_previmg, m_abmp, true);
	if( g_ImgMatEdit.m_external_tex.m_width != 0 && g_ImgMatEdit.m_external_tex.m_height != 0){
		control = (CStatic*)GetDlgItem(IDC_TEXIMG);
		DrawToStatic(control, ToNormalImage(g_ImgMatEdit.m_external_tex), m_abmp2, true);
	}
}

void CTextureDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default
	g_ImgMatEdit.m_retex_info.scalar_s = GetScalarS(m_scalar_s.GetPos());
	g_ImgMatEdit.m_retex_info.scalar_f = GetScalarF(m_scalar_f.GetPos());
	g_ImgMatEdit.m_retex_info.scalar_tex = GetScalarTex(m_scalar_tex.GetPos());
	g_ImgMatEdit.m_retex_info.tex_size = GetTexSize(m_txsize_slider.GetPos());

	static char buf[128];
	sprintf(buf, "%f", g_ImgMatEdit.m_retex_info.scalar_s);
	m_static_s.SetWindowText(buf);
	sprintf(buf, "%f", g_ImgMatEdit.m_retex_info.scalar_f);
	m_static_f.SetWindowText(buf);


	DoRetexture();

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CTextureDlg::OnBnClickedDarkGlass()
{
	m_dark_glass = !m_dark_glass;
	g_ImgMatEdit.m_retex_info.black_glass = m_dark_glass;

	DoRetexture();
}

void CTextureDlg::OnBnClickedHl()
{
	m_preserve_hl = !m_preserve_hl;

	g_ImgMatEdit.m_retex_info.preserve_hl = m_preserve_hl;
	DoRetexture();
}

void CTextureDlg::OnSetFocus(CWnd* pOldWnd)
{
	CDialog::OnSetFocus(pOldWnd);

	DoRetexture();
}

void CTextureDlg::OnBnClickedLoadtex()
{
	char buf[1024];
	CFileDialog dlg(true, "bmp", ".bmp", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT , "High Dynamic Range Image|*.bmp||");

	if( dlg.DoModal() == IDOK){
		strcpy(buf, dlg.GetFileName());
		g_ImgMatEdit.m_external_tex = ToFloatImage(ReadBmpFile(buf));

		CStatic* control = (CStatic*)GetDlgItem(IDC_TEXIMG);
		DrawToStatic(control, ToNormalImage(g_ImgMatEdit.m_external_tex), m_abmp2, true);
	}

	DoRetexture();
}
