#pragma once

#include "ImgMatEdit.h"
#include "afxcmn.h"
#include "AlignedBmpConvertor.h"
#include "afxwin.h"
// CTextureDlg dialog

const float s_max = 250.0f;
const float f_max = 1.0f;


class CTextureDlg : public CDialog
{
	DECLARE_DYNAMIC(CTextureDlg)

public:
	CTextureDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTextureDlg();

// Dialog Data
	enum { IDD = IDD_TEXTUREDLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
public:
	tx_mode m_texture_mode;
	fRGB m_color;
	afx_msg void OnBnClickedTransparancy();
	afx_msg void OnBnClickedExternal();
	afx_msg void OnBnClickedSetcolor();
	afx_msg void OnPaint();
	afx_msg void OnBnClickedDarkGlass();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedHl();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnBnClickedLoadtex();

	void DoRetexture();

public:
	CSliderCtrl m_scalar_s;
	CSliderCtrl m_scalar_f;
	CSliderCtrl m_scalar_tex;
	AlignedBmpConvertor m_abmp;
	AlignedBmpConvertor m_abmp2;

	CStatic m_static_s;
	CStatic m_static_f;
	bool m_dark_glass;
	bool m_preserve_hl;
	

private:
	inline float GetScalarS(int n){
		const float s_factor = s_max/1000.0f;
		return n * s_factor;
	}

	inline float GetScalarF(int n){
		const float f_factor = f_max/1000.0f;
		return n * f_factor;
	}

	inline float GetScalarTex(int n){
		const float tex_factor = 1.0f/1000.0f;
		return (float)(n*tex_factor);
	}

	inline float GetTexSize(int n){
		const float tex_factor = 2.0f/1000.0f;
		return (float)(n*tex_factor);
	}


	inline int GetPosFromS(float s){
		const float s_factor = 1000.0f/s_max;
		return (int)(s * s_factor);
	}

	inline int GetPosFromF(float f){
		const float f_factor = 1000.0f/f_max;
		return (int)(f * f_factor);
	}

	inline int GetPosFromTex(float tex){
		const float tex_factor = 1000.0f/1.0f;
		return (int)(tex*tex_factor);
	}

	inline int GetPosFromTexSize(float tex){
		const float tex_factor = 1000.0f/2.0f;
		return (int)(tex*tex_factor);
	}



	
public:


	CSliderCtrl m_txsize_slider;
};
