#pragma once
#include "stdafx.h"
#include "AlignedBmpConvertor.h"

inline bool DrawToStatic(CStatic* control, RgbImage & outimg, AlignedBmpConvertor & abmp, bool invert){

	CDC* pdc = NULL;
	CRect r;

	if( outimg.m_width != 0 && outimg.m_height != 0){
		control->GetClientRect(&r);


		float rate1 = (r.right-2)/(float)outimg.m_width;
		float rate2 = (r.bottom-2)/(float)outimg.m_height;
		float rate = min(rate1, rate2);
		if( rate > 1.0f )
			rate = 1.0f;

		int DestW = (int)(rate * outimg.m_width);
		int DestH = (int)(rate * outimg.m_height);
		int DestX = (r.right-2)/2 - DestW/2;
		int DestY = (r.bottom-2)/2 - DestH/2;

		pdc = control->GetDC();
		::SetStretchBltMode(pdc->m_hDC, COLORONCOLOR);
		if( invert ){
			::StretchDIBits(pdc->m_hDC,
				DestX,
				DestY + DestH,
				DestW,
				-DestH,
				0,
				0,
				outimg.m_width,
				outimg.m_height,
				(void*)abmp.GetAlignedData(outimg),
				&getBitmapInfo(outimg),
				DIB_RGB_COLORS,
				SRCCOPY);
		}else{
			::StretchDIBits(pdc->m_hDC,
				DestX,
				DestY,
				DestW,
				DestH,
				0,
				0,
				outimg.m_width,
				outimg.m_height,
				(void*)abmp.GetAlignedData(outimg),
				&getBitmapInfo(outimg),
				DIB_RGB_COLORS,
				SRCCOPY);
			
		}
		control->ReleaseDC(pdc);
		return true;
	}
	return false;
	
}